/* abcess.h -- functions used by compiled INTERCAL programs */

typedef INT32 bool;
#define TRUE	1L
#define FALSE	0L

#define ONESPOT	0L
#define TWOSPOT	1L
#define TAIL	2L
#define HYBRID	3L

/* the following two types must both promote to unsigned int in expressions */

typedef unsigned short type16;
typedef unsigned long  type32; /* wwp: was unsigned int */

typedef struct array_t
{
  UINT32 rank;
  UINT32 *dims;
  union
  {
    type16 *tail;
    type32 *hybrid;
  } data;
} array;

/* defined in cesspool.c */
extern void pushnext(INT32 n);
extern UINT32 popnext(INT32 n);
extern UINT32 resume(UINT32 n);
extern UINT32 pin(void);
extern void clockface(bool mode);
extern void pout(UINT32 val);
extern void binin(UINT32 type, array *a, bool forget);
extern void binout(UINT32 type, array *a);
extern UINT32 assign(char *dest, UINT32 type, bool forget, UINT32 value);
extern char *aref();
extern void resize();
extern void stashinit(void);
extern void stash(UINT32 type, UINT32 index, void *from);
extern void retrieve(void *to, INT32 type, UINT32 index, bool forget);
extern UINT32 roll(UINT32 n);

/* defined in arrgghh.c */
extern void parseargs(int argc, char **argv);

/* abcess.h ends here */
