
//
//   Filename:
//
//      getopt.c
//
//   Purpose:
//
//      This is a copy of the AT&T public domain getopt()
//
//   Authors:
//
//      Some unspecified AT&T weenie
//      WWP   William W. Patterson   AKMXE Bridgestone/Firestone Inc.
//
//   History:
//
//      000   1992.04.08   WWP   Copied from a CTI system, and prettied up a bit
//      001   1993.04.01   WWP   Minor reformatting
//      002   1995.03.11   WWP   Cast (int), to prevent annoying warning
//

#include <stdio.h>
#include <string.h>

#define GETOPTERR(s,c) \
   if (opterr) \
      { \
      char errbuf[2]; \
      errbuf[0] = c; \
      errbuf[1] = '\n'; \
      (void) write(2,argv[0],(unsigned)strlen(argv[0])); \
      (void) write(2,s,(unsigned)strlen(s)); \
      (void) write(2,errbuf,2); \
      }

int opterr = 1;
int optind = 1;
int optopt;
char *optarg;

int getopt( int argc, char **argv, char *opts )

   {

   static int sp = 1;
   register int c;
   register char *cp;

   if ( sp == 1 )
      {
      if ( optind>=argc || argv[optind][0]!='-' || argv[optind][1]=='\0' )
         {
         return(EOF);
         }
      else
         {
	 if ( strcmp(argv[optind],"--") == (int)NULL ) /* 002 */
            {
            ++optind;
            return(EOF);
            }
         }
      }

   optopt = c = argv[optind][sp];

   if ( c==':' || (cp=strchr(opts,c))==NULL )
      {
      GETOPTERR(": illegal option -- ", c);
      if ( argv[optind][++sp] == '\0' )
         {
         ++optind;
         sp = 1;
         }
      return('?');
      }

   if ( *++cp == ':' )
      {
      if ( argv[optind][sp+1] != '\0' )
         {
         optarg = &argv[optind++][sp+1];
         }
      else
         {
         if ( ++optind >= argc )
            {
            GETOPTERR(": option requires an argument -- ",c);
            sp = 1;
            return('?');
            }
         else
            {
            optarg = argv[optind++];
            }
         }
      sp = 1;
      }
   else
      {
      if ( argv[optind][++sp] == '\0' )
         {
         sp = 1;
         ++optind;
         }
      optarg = NULL;
      }

   return(c);

   }

