
//
//   File:
//
//      sleep.c
//
//   Function:
//
//      sleep(seconds)
//
// Purpose:
//
//    Delay program for specified number of seconds
//
// Notes:
//
//    Times are relative to when the process started.
//    Not neighborly in a multitasking environment, but it'll do for here.
//    There's a 50ms or so overhead, so don't call unless you really mean it!
//
// Authors:
//
//    William W. Patterson
//
// History:
//
//    1995.03.24  0.00  WWP   Creation - based on qc25 sample
//    1995.03.24  0.01  WWP   Return if argument negative!
//    1995.03.24  0.02  WWP   Use for loop
//    1995.03.24  0.03  WWP   I can do it in ONE statement! 8-)
//    1995.03.24  1.00  WWP   Cut! Print!
//    1996.06.12  1.01  WWP   Argument in seconds instead of ticks for INTERCAL
//    1996.06.12  1.02  WWP   Argument and return as int, so that function prototype is not necessary and we don't need to modify INTERCAL sources...
//

#include <time.h>

int sleep( int seconds )

   {

   clock_t ticks;
   clock_t WakeTime;
   clock_t Now;

   ticks = CLOCKS_PER_SEC * seconds;

   for (
      WakeTime = ( Now = clock() ) + ( ticks = ticks > 0 ? ticks : 1 );
      Now < WakeTime;
      Now = clock()
      );

   return 0;

   }

